{ Ondej Polacek - Hippo Games - GPL }
uses newdelay,crt,dos; {newdelay pro PII}
const ESCAPE= #27;
      UP= #72;
      DOWN= #80;
      LEFT= #75;
      RIGHT= #77;
      tps = 1000/55;

type VgaRamText = array[1..50,1..80] of
                  record
                    znak : char;
                    attr : byte;
                  end;
     THad= record
            smer: char;
            delka : byte;
            telo: array[1..20] of
                  record
                    x,y : byte;
                  end;
            obr : array[1..20] of char;
          end;
     MuzeBourat = record
                   delka : byte;
                   znaky : array[1..256] of char;
                  end;
     buf1 = array[1..32767] of word;

{namaluje hada na obrazovku
 viditeny = true- namalovat a ulozit co tam bylo predtim
 flase - placnout, to co tam bylo predim}

procedure malujhada(var h : THad; var vram : VgaRamText;viditelny : boolean);
var i : byte;
begin

  for i:= h.delka downto 1 do
   begin
    if viditelny then
     begin
      h.obr[i]:= vram[h.telo[i].Y,h.telo[i].X].znak;
      if i<>1 then vram[h.telo[i].Y,h.telo[i].X].znak:= '*'
       else
        case h.smer of
         UP : vram[h.telo[i].Y,h.telo[i].X].znak:= #30;
         DOWN : vram[h.telo[i].Y,h.telo[i].X].znak:= #31;
         LEFT : vram[h.telo[i].Y,h.telo[i].X].znak:= #17;
         RIGHT : vram[h.telo[i].Y,h.telo[i].X].znak:= #16;
        end;

     end else vram[h.telo[i].Y,h.telo[i].X].znak:= h.obr[i];
   end;

end;

procedure posunhada(newX,newY : byte; var h : THad);
var i : byte;
begin
  for i:= h.delka-1 downto 1 do
   begin
     h.telo[i+1].X:= h.telo[i].X;
     h.telo[i+1].Y:= h.telo[i].Y;
   end;
   h.telo[i].X:= newX;
   h.telo[i].Y:= newY;
end;

{namaluje ramecek}

procedure ramecek(var vr : VgaRamText);
var
   i : integer;
begin
 vr[1,1].znak:= #$da;
 vr[1,80].znak:= #$bf;
 vr[50,1].znak:= #$c0;
 vr[50,80].znak:= #$d9;
 for i:= 2 to 79 do vr[1,i].znak:= #$c4;
 for i:= 2 to 79 do vr[50,i].znak:= #$c4;
 for i:= 2 to 49 do vr[i,1].znak:= #$b3;
 for i:= 2 to 49 do vr[i,80].znak:= #$b3;
 vr[50,39].znak:= '[';
 vr[50,40].znak:= ']';
end;

{zisti, jestli had narazil}

function narazil(var h : THad;mb : MuzeBourat) : boolean;
var
  hlX,hlY,i : byte;
  naboural : boolean;
begin
 hlX:= h.telo[1].X;
 hlY:= h.telo[1].Y;
 naboural:= true;

 for i:= 0 to mb.delka do
   if mb.znaky[i+1]= h.obr[1] then
    begin
     naboural:= false;
     break;
    end;
 if (not naboural) and (h.obr[1]= #6) then
  begin
   inc(h.delka);
   h.telo[h.delka].X:= h.telo[h.delka-1].X;
   h.telo[h.delka].Y:= h.telo[h.delka-1].Y;
   h.obr[1]:= ' ';
  end;
 narazil:= naboural;
end;

{nacte obrazovku ulozenou v souboru}

function LoadTextScr(var v : VgaRamText;s : string) : boolean;
var f : file;
    h : array[1..4] of char;
begin
 {$I-}
 LoadTextScr:= false;
 assign(f,s);
 reset(f,1);
 if IOResult<>0 then exit;
 blockread(f,h,4);
 if h<> 'TEXT' then
  begin
   close(f);
   exit;
  end;
 blockread(f,v,8000);
 LoadTextScr:= true;
 close(f);
end;

{nacte song ulozeny v souboru}

function loadsound(var b : buf1;var soundRES : word;s: string) : boolean;
var
  head : array[1..4] of char; {buffer pro kontrolu hlavicky}
  f : file;

begin
  loadsound:= false;
  assign(f,s);     {soubor se zadava jako parametr}
  {$I-}
  reset(f,1);                {otevre se soubor}
  if IOResult<>0 then exit;
  blockread(f,head,4);        {nacte se hlavicka}
  if head<> 'ZSND' then       {je hlavicka dobre ? (rozpoznani formatu)}
    begin
     close(f);
     exit;
    end;
  blockread(f,soundRES,2);         {kolik polozek se bude cist ?}
  blockread(f,b,soundRES*2);  {nacteni bufferu buf, RES*2 - buffer je array of }
  close(f);                   {word, word= dva byte}
  loadsound:= true;
end;

var
  vram : VgaRamText absolute $B800:$0;
  i : integer;
  had : THad;
  A : char;
  kolo,kamX,kamY : byte;
  mb : MuzeBourat;
  otev : boolean;
  oldint1c : pointer;
  tick : integer;
  hodinky : longint;
  RYCHLOST : integer;
  soundRES : word;
  soundBUF : ^buf1;           {buffer}
  s : string;

{casovac}

procedure newint1c; interrupt;
begin
  inc(tick); {na melodii}
  inc(hodinky);  {na pocitani casu}
  if hodinky= MaxLongint then hodinky:= 0;
  if tick= soundRES then tick:= 1;
  if soundbuf^[tick] <> 0 then sound(soundbuf^[tick])
                         else nosound;

end;


begin
  TextMode(C80+ Font8x8);

  nosound;
  getmem(soundbuf,sizeof(soundbuf^));
  kolo:= 0;
  had.telo[1].Y:= 50; {Pro splneni podminky}
  had.delka:= 1;

  repeat
  if had.telo[1].Y= 50 then     {nove kolo ?}
    begin
     {dalsi kolo}
     inc(kolo);
     clrscr;

     if kolo<> 1 then
      begin
       writeln(kolo-1,'. kolo');
       writeln('cas      : ',round(hodinky*tps/100),' s');
       writeln('rychlost : ',RYCHLOST);
       readkey;
     end else
     begin
      writeln('Hippo HAD - Naprogramoval Ondrej Polacek');
      writeln;
      writeln('Ovladani - absolutni (sipkami), had muze nabourat i sam do sebe.');
      writeln('Ukolem je sebrat listecky a vjet do otevrenych dveri (po sebrani vsech listecku)');
      readkey;
     end;
     str(kolo,s);
     GetIntVec($1c,oldint1c);
     SetIntVec($1c,addr(newint1c));
     if not LoadTextScr(vram,s) then break;
     if not loadsound(soundbuf^,soundRES,s+ '.zsn') then break;
     otev:= false;
     ramecek(vram);
     RYCHLOST:= 250- kolo*20;
     with had do
      begin
       smer:= UP;
       delka:= 10;
       for i:= 1 to 10 do telo[i].X:= 40;
       for i:= 1 to 10 do telo[i].Y:= i+20;
      end;

     with mb do
      begin
       delka:= 2;
       znaky[1]:= ' ';
       znaky[2]:= #6;
      end;

     malujhada(had,vram,true);

     repeat until keypressed;
     hodinky:= 0;
    end;


  if keypressed then A:= readkey;
  if A=#0 then
   begin
    A:= readkey;
    if A in [UP,DOWN,LEFT,RIGHT] then had.smer:= A;
   end;

  malujhada(had,vram,false);

  case had.smer of
   UP : begin kamX:= had.telo[1].X; kamY:= had.telo[1].Y-1; end;
   DOWN : begin kamX:= had.telo[1].X; kamY:= had.telo[1].Y+1; end;
   LEFT : begin kamX:= had.telo[1].X-1; kamY:= had.telo[1].Y; end;
   RIGHT : begin kamX:= had.telo[1].X+1; kamY:= had.telo[1].Y; end;
  end;

  posunhada(kamX,kamY,had);

  malujhada(had,vram,true);

  if narazil(had,mb) then
   begin
    had.telo[1].Y:= 50;
    dec(kolo);
   end;
  if (had.delka=20) and (not otev) then {moznost vstupu do dalsiho levelu}
   begin                                {otevrou se vratka}
    vram[50,38].znak:= '[';
    vram[50,39].znak:= ' ';
    vram[50,40].znak:= ' ';
    vram[50,41].znak:= ']';
    otev:= true;
   end;

  if A<> ESCAPE then
   begin
    delay(RYCHLOST);
   end;

  until A= ESCAPE;

  SetIntVec($1c,oldint1c);
  nosound;

  TextMode(C80);
  clrscr;
end.
